apiVersion: tekton.dev/v1beta1
kind: Task
metadata:
  labels:
    {{ network_policy_deployment_label }}: job-{{ tekton_name }}
    version: "{{ tekton_assets_version }}"
  name: node-s2i-build-buildah
  namespace: {{ buildns }}
spec:
  params:
  - default: .
    description: The location of the path to run s2i from
    name: contextdir
    type: string
  - name: dstimage
    description: Where to push the resulting image
    type: string
  - default: {{ npmjs_registry }}
    description: NPMJS Repository Endpoint
    name: npmmirror
    type: string
  - default: nodejs:master
    description: S2i Base Image
    name: fromimage
    type: string
  - default: "true"
    description: Verify the TLS on the registry endpoint (for push/pull to a non-TLS registry)
    name: tlsverify
    type: string
  results:
  - description: Digest of the image just built.
    name: IMAGE_DIGEST
  steps:
  - args:
    - -c
    - |
        . /usr/local/bin/set_runtime
        echo NODE_ENV=production >>/env-params/env-file
        echo NO_AUDIT=yep >>/env-params/env-file
        if test "$(params.npmmirror)"; then
            echo NPM_MIRROR=$(params.npmmirror) >>/env-params/env-file
        fi
{% if proxy_host | default(False) %}
        echo http_proxy=http://{{ proxy_host }}:{{ proxy_port | default('3128') }} >>/env-params/env-file
        echo https_proxy=http://{{ proxy_host }}:{{ proxy_port | default('3128') }} >>/env-params/env-file
        echo no_proxy="{% if (no_proxy | default([])) | length > 0 %}{{ no_proxy | join(',') }},{% endif %}.{{ k8s_registry_ns }}.svc.{{ cluster_domain }},.{{ k8s_registry_ns }}.svc,.{{ k8s_registry_ns }},.{{ buildns }}.svc.{{ cluster_domain }},.{{ buildns }}.svc,.{{ buildns }},.svc.{{ cluster_domain }},.svc,.{{ cluster_domain }},.local,.{{ root_domain }}" >>/env-params/env-file
        echo HTTP_PROXY=http://{{ proxy_host }}:{{ proxy_port | default('3128') }} >>/env-params/env-file
        echo HTTPS_PROXY=http://{{ proxy_host }}:{{ proxy_port | default('3128') }} >>/env-params/env-file
        echo NO_PROXY="{% if (no_proxy | default([])) | length > 0 %}{{ no_proxy | join(',') }},{% endif %}.{{ k8s_registry_ns }}.svc.{{ cluster_domain }},.{{ k8s_registry_ns }}.svc,.{{ k8s_registry_ns }},.{{ buildns }}.svc.{{ cluster_domain }},.{{ buildns }}.svc,.{{ buildns }},.svc.{{ cluster_domain }},.svc,.{{ cluster_domain }},.local,.{{ root_domain }}" >>/env-params/env-file
{% elif squid_address is defined %}
        echo http_proxy={{ squid_address }} >>/env-params/env-file
        echo https_proxy={{ squid_address }} >>/env-params/env-file
        echo no_proxy="{% if (no_proxy | default([])) | length > 0 %}{{ no_proxy | join(',') }},{% endif %}.{{ k8s_registry_ns }}.svc.{{ cluster_domain }},.{{ k8s_registry_ns }}.svc,.{{ k8s_registry_ns }},.{{ buildns }}.svc.{{ cluster_domain }},.{{ buildns }}.svc,.{{ buildns }},.svc.{{ cluster_domain }},.svc,.{{ cluster_domain }},.local,.{{ root_domain }}" >>/env-params/env-file
        echo HTTP_PROXY={{ squid_address }} >>/env-params/env-file
        echo HTTPS_PROXY={{ squid_address }} >>/env-params/env-file
        echo NO_PROXY="{% if (no_proxy | default([])) | length > 0 %}{{ no_proxy | join(',') }},{% endif %}.{{ k8s_registry_ns }}.svc.{{ cluster_domain }},.{{ k8s_registry_ns }}.svc,.{{ k8s_registry_ns }},.{{ buildns }}.svc.{{ cluster_domain }},.{{ buildns }}.svc,.{{ buildns }},.svc.{{ cluster_domain }},.svc,.{{ cluster_domain }},.local,.{{ root_domain }}" >>/env-params/env-file
{% endif %}
    command:
    - /bin/sh
    image: {{ (opsimages | json_query("[?name=='alpine'].image"))[0] }}
    name: generate-environ
{% if tekton_uses_resources_limits | default(True) %}
    resources:
      limits:
        cpu: "{{ tekton_scripts_cpu_limit }}"
        memory: {{ tekton_scripts_memory_limit }}
      requests:
        cpu: "{{ tekton_scripts_cpu_request }}"
        memory: {{ tekton_scripts_memory_request }}
{% else %}
    resources: {}
{% endif %}
{% if k8s_flavor == 'kubernetes' %}
    securityContext:
      runAsUser: {{ k8s_unprivileged_userid }}
{% endif %}
    volumeMounts:
    - mountPath: /env-params
      name: envparams
    workingDir: "$(workspaces.source.path)"
  - command:
    - s2i
    - build
    - $(params.contextdir)
{% if k8s_flavor == 'kubernetes' %}
    - {{ docker_registry }}/{{ buildns }}/$(params.fromimage)
{% else %}
    - $(params.fromimage)
{% endif %}
    - --image-scripts-url
    - image:///usr/libexec/s2i
    - --as-dockerfile
    - /gen-source/Dockerfile.gen
    - --environment-file
    - /env-params/env-file
    image: {{ tekton_s2i_image }}
    name: generate-image-build-assets
{% if tekton_uses_resources_limits | default(True) %}
    resources:
      limits:
        cpu: "{{ tekton_s2i_build_cpu_limit }}"
        memory: {{ tekton_s2i_build_memory_limit }}
      requests:
        cpu: "{{ tekton_s2i_build_cpu_request }}"
        memory: {{ tekton_s2i_build_memory_request }}
{% else %}
    resources: {}
{% endif %}
{% if k8s_flavor == 'kubernetes' %}
    securityContext:
{% if 0 == 1 %}
      runAsUser: {{ k8s_unprivileged_userid }}
{% else %}
      privileged: true
{% endif %}
{% endif %}
    volumeMounts:
    - mountPath: /gen-source
      name: gen-source
    - mountPath: /env-params
      name: envparams
    workingDir: "$(workspaces.source.path)"
  - command:
    - buildah
    - bud
{% if k8s_flavor == 'openshift' %}
    - --storage-driver
    - vfs
{% else %}
    - --squash
{% endif %}
    - --tls-verify=$(params.tlsverify)
    - --layers
    - -f
    - /gen-source/Dockerfile.gen
    - -t
    - $(params.dstimage)
    - .
{% if proxy_host | default(False) %}
    env:
    - name: http_proxy
      value: http://{{ proxy_host }}:{{ proxy_port | default('3128') }}
    - name: https_proxy
      value: http://{{ proxy_host }}:{{ proxy_port | default('3128') }}
    - name: no_proxy
      value: "{% if (no_proxy | default([])) | length > 0 %}{{ no_proxy | join(',') }},{% endif %}.{{ k8s_registry_ns }}.svc.{{ cluster_domain }},.{{ k8s_registry_ns }}.svc,.{{ k8s_registry_ns }},.{{ buildns }}.svc.{{ cluster_domain }},.{{ buildns }}.svc,.{{ buildns }},.svc.{{ cluster_domain }},.svc,.{{ cluster_domain }},.local,.{{ root_domain }}"
    - name: HTTP_PROXY
      value: http://{{ proxy_host }}:{{ proxy_port | default('3128') }}
    - name: HTTPS_PROXY
      value: http://{{ proxy_host }}:{{ proxy_port | default('3128') }}
    - name: NO_PROXY
      value: "{% if (no_proxy | default([])) | length > 0 %}{{ no_proxy | join(',') }},{% endif %}.{{ k8s_registry_ns }}.svc.{{ cluster_domain }},.{{ k8s_registry_ns }}.svc,.{{ k8s_registry_ns }},.{{ buildns }}.svc.{{ cluster_domain }},.{{ buildns }}.svc,.{{ buildns }},.svc.{{ cluster_domain }},.svc,.{{ cluster_domain }},.local,.{{ root_domain }}"
{% elif squid_address is defined %}
    env:
    - name: http_proxy
      value: {{ squid_address }}
    - name: https_proxy
      value: {{ squid_address }}
    - name: no_proxy
      value: "{% if (no_proxy | default([])) | length > 0 %}{{ no_proxy | join(',') }},{% endif %}.{{ k8s_registry_ns }}.svc.{{ cluster_domain }},.{{ k8s_registry_ns }}.svc,.{{ k8s_registry_ns }},.{{ buildns }}.svc.{{ cluster_domain }},.{{ buildns }}.svc,.{{ buildns }},.svc.{{ cluster_domain }},.svc,.{{ cluster_domain }},.local,.{{ root_domain }}"
    - name: HTTP_PROXY
      value: {{ squid_address }}
    - name: HTTPS_PROXY
      value: {{ squid_address }}
    - name: NO_PROXY
      value: "{% if (no_proxy | default([])) | length > 0 %}{{ no_proxy | join(',') }},{% endif %}.{{ k8s_registry_ns }}.svc.{{ cluster_domain }},.{{ k8s_registry_ns }}.svc,.{{ k8s_registry_ns }},.{{ buildns }}.svc.{{ cluster_domain }},.{{ buildns }}.svc,.{{ buildns }},.svc.{{ cluster_domain }},.svc,.{{ cluster_domain }},.local,.{{ root_domain }}"
{% endif %}
    image: {{ tekton_buildah_image }}
    name: build
{% if tekton_uses_resources_limits | default(True) %}
    resources:
      limits:
        cpu: "{{ tekton_docker_build_cpu_limit }}"
        memory: {{ tekton_docker_build_memory_limit }}
      requests:
        cpu: "{{ tekton_docker_build_cpu_request }}"
        memory: {{ tekton_docker_build_memory_request }}
{% else %}
    resources: {}
{% endif %}
{% if k8s_flavor == 'kubernetes' %}
    securityContext:
{% if 0 == 1 %}
      runAsUser: {{ k8s_unprivileged_userid }}
{% else %}
      privileged: true
{% endif %}
{% endif %}
    volumeMounts:
    - mountPath: /dev/fuse
      name: devfuse
    - mountPath: /var/lib/containers
      name: varlibcontainers
    - mountPath: /gen-source
      name: gen-source
    workingDir: /gen-source
  - command:
    - buildah
    - push
{% if k8s_flavor == 'openshift' %}
    - --storage-driver
    - vfs
{% endif %}
    - --tls-verify=$(params.tlsverify)
    - --digestfile
    - $(workspaces.source.path)/image-digest
    - $(params.dstimage)
    - docker://$(params.dstimage)
    image: {{ tekton_buildah_image }}
    name: push
{% if k8s_flavor == 'kubernetes' %}
    securityContext:
{% if 0 == 1 %}
      runAsUser: {{ k8s_unprivileged_userid }}
{% else %}
      privileged: true
{% endif %}
{% endif %}
    volumeMounts:
    - mountPath: /dev/fuse
      name: devfuse
    - mountPath: /var/lib/containers
      name: varlibcontainers
  - args:
    - -c
    - |
{% if do_debugs %}
        set -x;
        ls $(workspaces.source.path)
        cat $(workspaces.source.path)/image-digest || echo no digest
{% endif %}
        cat $(workspaces.source.path)/image-digest | tee $(results.IMAGE_DIGEST.path)
    command:
    - /bin/sh
    image: {{ (opsimages | json_query("[?name=='alpine'].image"))[0] }}
    name: digest-to-results
{% if tekton_uses_resources_limits | default(True) %}
    resources:
      limits:
        cpu: "{{ tekton_scripts_cpu_limit }}"
        memory: {{ tekton_scripts_memory_limit }}
      requests:
        cpu: "{{ tekton_scripts_cpu_request }}"
        memory: {{ tekton_scripts_memory_request }}
{% else %}
    resources: {}
{% endif %}
  volumes:
  - hostPath:
      path: /dev/fuse
    name: devfuse
  - emptyDir: {}
    name: envparams
  - emptyDir: {}
    name: gen-source
  - emptyDir: {}
    name: varlibcontainers
  workspaces:
  - name: source
